module MoreAccurate
  class MoreAccurate
      attr_accessor :original_list, :word_list , :already_tried_letters

      def word_list=(list)
        @original_list = list.dup
      end

      def new_game(guesses_left)
        @already_tried_letters = []
        @last_guess_correct = true
        @word_list = @original_list
      end

      def guess(word, guesses_left)
        filter_word_list_by_word_pattern(word)  if @last_guess_correct        
        letter_with_least_worst_case 
      end

      def incorrect_guess(guess)
        @last_guess_correct = false
        @already_tried_letters << guess
        filter_word_list_by_incorrect_letter guess
      end

      def correct_guess(guess)
        @last_guess_correct = true
        @already_tried_letters << guess
      end

      def fail(reason)
      end

      def game_result(result, word)
      end

      def letter_with_least_worst_case
        least_worst_case_so_far = @word_list.size + 1
        potential_remaining_letters.each do |letter|
          matches,non_matches = @word_list.partition{|word| word.include?(letter)}
          next if non_matches.size >= least_worst_case_so_far                
          if non_matches.size >= half_the_word_list_size
            least_worst_case_so_far = non_matches.size
            @least_worse_case_letter = letter
          else
            parts = Hash.new{|hash, key| hash[key] = 0}
            parts['non_matches'] = non_matches.size
            matches.each do |word|
              masked_word = word.tr('^'+letter,'*')
              parts[masked_word] += 1
              next if parts[masked_word] > least_worst_case_so_far
            end
            if parts.values.last < least_worst_case_so_far
              least_worst_case_so_far = parts.values.last
              @least_worse_case_letter = letter
            end
          end
        end
        @least_worse_case_letter
      end

      def potential_remaining_letters
        @word_list.join.split(//).uniq - already_tried_letters
      end

      def regex_from_word_pattern(word_pattern)
        @already_tried_letters.last
        Regexp.new('^' + word_pattern.gsub(/_/, "[^#{@already_tried_letters.last || '\d'}]") + '$', true)
      end

      def filter_word_list_by_word_pattern(word_pattern)
        @word_list = @word_list.select do |word|
          regex_from_word_pattern(word_pattern).match word
        end
      end

      def filter_word_list_by_incorrect_letter(guess)
        @word_list.reject! {|word| word.include?(guess)}
      end
            
      def half_the_word_list_size
        @word_list.size / 2
      end

    end
end